import java.util.concurrent.Semaphore;
// ========================================================================
// BarberSemaphore in Java
// ------------------------------------------------------------------------
// Usage:
// javac BarberSemaphore.java
// java BarberSemaphore nbChairs nbCustomers
// ========================================================================
/**
* Simulate barber behaviors with Semaphore.
*
*/
public class BarberSemaphore extends Thread {
/** Semaphores */
private Semaphore busyChairsC, barberChairC;
public BarberSemaphore(Semaphore busyChairs, Semaphore barberChair) {
this.busyChairsC = busyChairs;
this.barberChairC = barberChair;
}
/*
* (non-Javadoc)
*
* @see java.lang.Runnable#run()
*/
public void run() {
    while (true) {
    try {
        System.out.println("waiting for customer ...");
        busyChairsC.acquire();
        System.out.println("Customer arrive ! go to work...");
        barberChairC.release();
        Thread.sleep(1000);
    } catch (Exception e) {
    System.out.println("haircut interrupted");
    }
    System.out.println("Haircut is over");
    }
}
}